<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
<meta http-equiv="pragma" content="no-cache">
<meta name="Author" content="Michiel Dethmers, michiel@kipu.co.uk">
<meta name="Package" content="PHPList 1.1.1b, 16 October 2000">
<meta name="More Information" content="http://www.phplist.com">
	<title>Process the Message queue</title>
</head>

<body>
<?
include "header.inc";
include "config.php";

# report keeps track of what's going on
$report = "";

function shutdown () {
  global $report,$send_process_id;
  DB_Query("Update sendprocess set alive = 0 where id = $send_process_id");
  finish("info",$report);
}

register_shutdown_function("shutdown");

## some general functions
function finish ($flag,$message) {
  global $report_address;
  if ($flag == "error") {
    $subject = "Maillist Errors";
  } elseif ($flag == "info") {
    $subject = "Maillist Processing info";
  }
  mail ($report_address,$subject,$message);
  register_shutdown_function("");
  exit;
}

function ProcessError ($message) {
  print "$message<br>\n";
  finish("error",$message);
}

function output ($message) {
  global $report;
  $infostring = "[". date("D j M Y H:i",time()) . "] [" . getenv("REMOTE_HOST") ."] [" . getenv("REMOTE_ADDR") ."]";
  print "$infostring $message<br>\n";
  $report .= "\n$infostring $message";
  flush();
}

function sendEmailTest ($messageid,$email,$name) {
  print "(test) Would have sent $messageid to $email, $name<br>\n";
}

function sendEmail ($messageid,$email,$name,$hash) {
  if ($email == "")
    return;
  global $unsubscribe_url,$host;
  if (!$cached[$messageid]) {
    $message = DB_query("select * from message where id = $messageid");
    $cached[$messageid] = "yes";
    $message = DB_fetch_array($message);
    if (ereg("([^ ]+@[^ ]+)",$message["fromfield"],$regs)) {
      # if there is an email in the from, rewrite it as "name <email>"
      $message["fromfield"] = ereg_replace($regs[0],"",$message["fromfield"]);
      $from[$messageid] = stripslashes($message["fromfield"])." <$regs[0]>";
    } elseif (ereg(" ",$message["fromfield"],$regs)) {
      # if there is a space, we need to add the email
      $from[$messageid] = stripslashes($message["fromfield"]) . "<listmaster@$host>";
    } else {
      $from[$messageid] = stripslashes($message["fromfield"]) . "@$host";
    }
    # erase double spacing
    eregi_replace("  "," ",$from["$messageid"]);
    $to[$messageid] = stripslashes($message["tofield"]);
    $subject[$messageid] = stripslashes($message["subject"]);
    $replyto[$messageid] = stripslashes($message["replyto"]);
    $messagebody[$messageid] = stripslashes($message["message"]);
    $footer[$messageid] = stripslashes($message["footer"]);
  }
  output("Sending message $messageid with subject $subject[$messageid] to $email\n");
  
  $additional = "X-ListMember: $email\nPrecedence: bulk\nFrom: $from[$messageid]\n";
  if ($replyto[$messageid])
    $additional .= "Reply-To: $replyto[$messageid]\n";

  $msg = eregi_replace("\[NAME\]",$name,$messagebody[$messageid]);
  $footer = eregi_replace("\[UNSUBSCRIBE\]",$unsubscribe_url . sprintf('?hash=%s',$hash),$footer[$messageid]);
  $msg = $msg . "\n" . $footer;

  mail($email,$subject[$messageid],$msg,$additional);
}

# we don't want to timeout or abort
$abort = ignore_user_abort(1);
set_time_limit(600);
print Menu() . "<p>";

output("Started");

# check for other processes running
$running_req = DB_Query("select now() - modified,id from sendprocess where alive order by started desc");
$running_res = DB_Fetch_row($running_req);
while ($running_res[1]) { # a process is already running
  output ("A send process is already running and it was still alive $running_res[0] seconds ago");
  output ("Sleeping for 20 seconds, aborting will now quit");
  $abort = ignore_user_abort(0);
  sleep(20);
  $running_req = DB_Query("select now() - modified,id from sendprocess where alive order by started desc");
  $running_res = DB_Fetch_row($running_req);
  if ($running_res[0] > 600)
    # process has been inactive for too long, kill it
    DB_Query("update sendprocess set alive = 0 where id = $running_res[1]");
}      
$res = DB_Query('insert into sendprocess (started,alive,ipaddress) values(now(),1,"'.getenv("REMOTE_ADDR").'")');
$send_process_id = DB_Insert_Id();
$abort = ignore_user_abort(1);

$messages = DB_query("select id,userselection from message where status != \"sent\"");
$num = DB_affected_rows();
if (DB_Has_Error($database_connection)) {  ProcessError(DB_Error($database_connection)); }

if ($num)
  print "<font color=red>Processing has started, $num message(s) to process. It is safe to click your stop button now, report will be sent by email</font><br>";
flush();

while ($message = DB_fetch_row($messages)) {
  $messageid = $message[0];
  $userselection = $message[1];
  output("Processing message $messageid");
  flush();
  DB_Query("Update sendprocess set alive = alive + 1 where id = $send_process_id");
  $status = DB_query('update message set status = "inprocess" where id = '.$messageid);
  output( "Looking for users");
  DB_query("SET SQL_BIG_TABLES=1");
  if (DB_Has_Error($database_connection)) {  ProcessError(DB_Error($database_connection)); }
  
  # make selection on attribute, users who at least apply to the attributes
  if ($userselection) {
    $res = DB_Query($userselection);
    $num = DB_Affected_rows($res);
    output("$num users apply for attributes, now checking lists");
    $user_list = "";
    while ($row = DB_Fetch_row($res)) {
      $user_list .= $row[0] . ",";
    }
    $user_list = substr($user_list,0,-1);
    if ($user_list)
      $user_attribute_query = " and listuser.userid in ($user_list)";
  } 
  $query = "select distinct listuser.userid from listuser,listmessage,user_attribute ";
  $query .= "where listmessage.messageid = $messageid and listmessage.listid = listuser.listid";
  $query .= " and user_attribute.userid = listuser.userid $user_attribute_query";
  $userids = DB_query("$query");
  if (DB_Has_Error($database_connection)) {  ProcessError(DB_Error($database_connection)); }

  # now we have all our users to send the message to
  $num = DB_affected_rows();
  output( "Found them: $num to process");
  while ($userdata = DB_fetch_row($userids)) {
    set_time_limit(60);
    # check if we've been "killed"
    $res = DB_Query("select alive from sendprocess where id = $send_process_id");
    $row = DB_Fetch_Row($res);
    if ($row[0]) 
      DB_Query("Update sendprocess set alive = alive + 1 where id = $send_process_id");
    else
      Process_Error("Process Killed by other process");
    flush();
    $someusers = 1;
    $user = $userdata[0];
    $users = DB_query("select user.id,user.name,user.email,user.uniqid from user where id = \"$user\"");

    # pick the first one
    $user = DB_fetch_row($users);
    $useremail = $user[2];
    $username = $user[1];
    $userid = $user[0];
    $userhash = $user[3];
    
    # avoid duplication when sending went wrong half way
    $um = DB_query("select id,entered from usermessage where userid = $userid and messageid = $messageid");
    $done = DB_fetch_array($um);
    if (!$done["id"]) {
      if (!TEST) {
        sendEmail($messageid,$useremail,$username,$userhash);
      } else {
        sendEmailTest($messageid,$useremail,$username);
      }
    } else {
      output( "Not sending to $useremail, already sent ".$done["entered"]);
    }
    $status = DB_query("update message set processed = processed +1 where id = \"$messageid\"");
    $um = DB_query("replace into usermessage (userid,messageid) values($userid,$messageid)");
    
    # update possible other users matching this email as well,
    # to avoid duplicate sending when people have subscribed multiple times
    $emails = DB_Query("select * from user where email =\"$useremail\"");
    while ($email = DB_fetch_row($emails)) {
      $um = DB_query("replace into usermessage (userid,messageid) values($email[0],$messageid)");
    }
  }
  if (!$someusers)
    output( "Hmmm, No users found to send to");
  $someusers = 0;
  $status = DB_query("update message set status = \"sent\",sent = now() where id = \"$messageid\"");
  $some = 1;
}

if (!$some) 
  output("Finished, Nothing to do");
  
if ($some)
  output("Finished, All done");

# shutdown will take care of reporting  

include "footer.inc";

?>

